import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import {AppComponent} from "./app.component";
import {AdminDashboardComponent} from "./admin-dashboard/admin-dashboard.component";
import {MainComponent} from "./main/main.component";
import {UserSettingsComponent} from "./user-settings/user-settings.component";
import {TaskgroupDashboardComponent} from "./taskgroups/taskgroup-dashboard/taskgroup-dashboard.component";
import {TaskDetailOverviewComponent} from "./tasks/task-detail-overview/task-detail-overview.component";
import {SchedulerComponent} from "./schedules/scheduler/scheduler.component";
import {MissedSchedulesComponent} from "./missed-schedules/missed-schedules.component";
import {OverdueTaskOverviewComponent} from "./overdue-task-overview/overdue-task-overview.component";
import {UpcomingTaskOverviewComponent} from "./upcoming-task-overview/upcoming-task-overview.component";
import {ActiveTaskOverviewComponent} from "./active-task-overview/active-task-overview.component";
import {DraggableSchedulerComponent} from "./schedules/draggable-scheduler/draggable-scheduler.component";
import {
  ForgottenTaskStartDialogComponent
} from "./dashboard/forgotten-task-start-dialog/forgotten-task-start-dialog.component";
import {TaskgroupActivityComponent} from "./statistics/taskgroup-activity/taskgroup-activity.component";
import {ScheduleHistoryComponent} from "./statistics/schedule-history/schedule-history.component";
import {UpcomingDeadlinesOverviewComponent} from "./upcoming-deadlines-overview/upcoming-deadlines-overview.component";

const routes: Routes = [
  {path: '', component: MainComponent},
  {path: 'admin', component: AdminDashboardComponent},
  {path: 'user/settings', component: UserSettingsComponent},
  {path: 'taskgroups', component: TaskgroupDashboardComponent},
  {path: 'taskgroups/:taskgroupID', component: TaskgroupDashboardComponent},
  {path: 'taskgroups/:taskgroupID/tasks/:taskID', component: TaskDetailOverviewComponent},
  {path: 'taskgroups/:taskgroupID/tasks/:taskID/schedule', component: SchedulerComponent},
  {path: 'taskgroups/:taskgroupID/tasks/:taskID/schedule/:scheduleID', component: SchedulerComponent},
  {path: 'reschedule', component: MissedSchedulesComponent},
  {path: 'overdue', component: OverdueTaskOverviewComponent},
  {path: 'upcoming', component: UpcomingTaskOverviewComponent},
  {path: 'active', component: ActiveTaskOverviewComponent},
  {path: 'scheduler', component: DraggableSchedulerComponent},
  {path: 'forgotten', component: ForgottenTaskStartDialogComponent},
  {path: 'statistics/taskgroup-activity', component: TaskgroupActivityComponent},
  {path: 'statistics/schedule-history', component: ScheduleHistoryComponent},
  {path: 'deadlines', component: UpcomingDeadlinesOverviewComponent}
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
