import {Component, Input, OnChanges, ViewChild} from '@angular/core';

import {
  ApexAxisChartSeries,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexChart,
  ApexPlotOptions, ChartComponent, ApexXAxis, ApexYAxis, ApexTooltip
} from "ng-apexcharts";
import {generate} from "rxjs";
import * as moment from "moment";
import {HistoryService, TaskgroupActivityInfo, TaskgroupPathInfo} from "../../../../api";

export type ChartOptions = {
  series: ApexAxisChartSeries;
  chart: ApexChart;
  dataLabels: ApexDataLabels;
  title: ApexTitleSubtitle;
  plotOptions: ApexPlotOptions;
  xAxis: ApexXAxis,
  yAxis: ApexYAxis,
  tooltip: ApexTooltip
};
@Component({
  selector: 'app-heatmap-activity',
  templateUrl: './heatmap-activity.component.html',
  styleUrls: ['./heatmap-activity.component.css']
})
export class HeatmapActivityComponent implements OnChanges{

  @ViewChild("chart") chart: ChartComponent | undefined;
  @Input() selectedTaskgroupPath: TaskgroupPathInfo | undefined
  public chartOptions: Partial<ChartOptions> | undefined;

  maxValue = 120

  constructor(private historyService: HistoryService) {

  }

  ngOnChanges() {
    if(this.selectedTaskgroupPath != undefined) {
      /*this.historyService.statisticsTaskgroupActivityTaskgroupIDStartingDateEndingDateIncludeSubTaskgroupsGet(
        this.selectedTaskgroupPath!.rootTasktroup.taskgroupID,
        moment().startOf('year').format("YYYY-MM-DD"),
        moment().endOf("year").format("YYYY-MM-DD"),
        false
      ).subscribe({
        next: resp => {
          const taskgroupActivityInfo = resp;
          console.log("Chat Options")
          this.chartOptions = {
            series: [
              {
                name: "Monday",
                data: this.generateData(moment().startOf('year'),taskgroupActivityInfo)
              },
              {
                name: "Tuesday",
                data: this.generateData(moment().startOf('year').add(1, "days"),taskgroupActivityInfo)
              },
              {
                name: "Wednesday",
                data: this.generateData(moment().startOf('year').add(2, "days"), taskgroupActivityInfo)
              },
              {
                name: "Thursday",
                data: this.generateData(moment().startOf('year').add(3, "days"), taskgroupActivityInfo)
              },
              {
                name: "Friday",
                data: this.generateData(moment().startOf('year').add(4, "days"), taskgroupActivityInfo)
              },
              {
                name: "Saturday",
                data: this.generateData(moment().startOf('year').add(5, "days"), taskgroupActivityInfo)
              },
              {
                name: "Sunday",
                data: this.generateData(moment().startOf('year').add(6, "days"), taskgroupActivityInfo)
              }
            ],
            chart: {
              height: 350,
              type: "heatmap"
            },
            xAxis: {
              labels: {
                show: false
              }
            },
            yAxis: {
              labels: {
                show: true
              }
            },
            plotOptions: {
              heatmap: {
                shadeIntensity: 0.5,
                colorScale: {
                  ranges: [
                    {
                      from: 0,
                      to: 5,
                      name: "low",
                      color: "#00A100"
                    },
                    {
                      from: 6,
                      to: 20,
                      name: "medium",
                      color: "#128FD9"
                    },
                    {
                      from: 21,
                      to: 45,
                      name: "high",
                      color: "#FFB200"
                    },
                    {
                      from: 46,
                      to: this.maxValue,
                      name: "extreme",
                      color: "#FF0000"
                    }
                  ]
                }
              }
            },
            dataLabels: {
              enabled: true,
              style: {
                fontSize: "12px"
              }
            },
            title: {
              text: "HeatMap Chart with Color Range"
            },
            tooltip: {
              enabled: true,
              y: {
                formatter: function (value, { seriesIndex, dataPointIndex, w }) {
                  return "<span style='font-weight: normal'>Spent </span>" +  value + " <span style='font-weight: normal'>Minutes on <br>" + w.config.series[seriesIndex].data[dataPointIndex].extraInfo.format("dddd, MMMM D, YYYY") + "</span>"
                },
                title: {
                  formatter: seriesName => ""
                }
              }
            }
          };
        }
      })*/
    }
  }

  private generateData(startingDate: moment.Moment, data: TaskgroupActivityInfo[]) {
    let currentDate = startingDate;

    let series = []
    let endingDate = startingDate.clone().endOf('year');

    while(currentDate.isBefore(endingDate)) {
      let x = "w" + currentDate.isoWeek();
      let y = this.findTaskgroupActivityInfoByDate(currentDate, data)
      let extraInfo = currentDate.clone()

      series.push({
        x: x,
        y: y,
        extraInfo: extraInfo
      })
      currentDate = currentDate.add(7, "days");
    }
    return series;
  }

  private findTaskgroupActivityInfoByDate(date: moment.Moment, data: TaskgroupActivityInfo[]) {
    //return data.find(taskActivity => moment(taskActivity.date).isSame(date))
  }
}
